''E_IR_Remote

CON
NoNewCode   = 255
NoNewDev    = 255
gapMin      = 2000
startBitMin = 2000
startBitMax = 2800
oneBitMin   = 1000
oneBitMax   = 1400

one   = 0

chup  = 16
power = 21

'power2 = 21
one2 = 0
two2 = 1

VAR
  byte cog
  long stack[20]

PUB Start(Pin, addrMainCode, addrMainDev) : result

  stop
  byte[addrMainCode] := NoNewCode
  byte[addrMainDev]  := NoNewDev
  cog := cognew(getSonyCode(Pin, addrMainCode, addrMainDev), @stack) + 1
  result := cog

PUB stop
  if cog
    cogstop(cog~ -1)

PUB getSonyCode(Pin, addrMainCode, addrMainDev) | irCode, irDev, index, pulseWidth, lockID

  frqa := 1
  ctra := 0
  dira[Pin]~

  repeat
    ctra := (%10101 << 26) | (Pin)
    waitpne(0 << Pin, |< Pin, 0)
    phsa := 0
    waitpeq(0 << Pin, |< Pin, 0)
    waitpne(0 << Pin, |< Pin, 0)

    pulseWidth := phsa / (clkfreq / 1_000_000) + 1

  while (( pulseWidth < startBitMin) OR (pulseWidth > startBitMax))

  index := 0
  irCode := 0
  repeat
    ctra := (%10101 << 26) | (Pin)
    waitpne(0 << Pin, |< Pin, 0)
    phsa := 0
    waitpeq(0 << Pin, |< Pin, 0)
    waitpne(0 << Pin, |< Pin, 0)

    pulseWidth := phsa / (clkfreq / 1_000_000) + 1

   if (pulseWidth > oneBitMin) AND (pulseWidth < oneBitMax)
      irCode := irCode + (1 << index)
   index++
  while index < 11
  irDev  := (irCode & $f80) >> 7  ''Masking of upper 5 bits
  irCode := irCode & $7f   ''Masking of lower 7 bits


  byte[addrMainCode] := irCode
  byte[addrMainDev]  := irDev   ''byte[addrMainDev] = upper 5 bits